﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestingLinqToSQLMockA
{
    //Because we are using an interface the class cannot be static.
    public class LinqProductRepository : IProductRepository
    {
        public List<Category> GetCategories()
        {
            using (HowToUnitTestDataContext db = CreateDataContext())
            {
                var query = from c in db.Categories
                            select c;
                return query.ToList();
            }
        }

        public Category GetCategory(string categoryTitle)
        {
            using (HowToUnitTestDataContext db = CreateDataContext())
            {
                Category category = db.Categories.Single(c => c.Title == categoryTitle);
                return category;
            }
        }

        public List<Product> GetProductsForCategory(Category c)
        {
            using (HowToUnitTestDataContext db = CreateDataContext())
            {
                var query = from p in db.Products
                            join pc in db.ProductCategories on p.id equals pc.ProductID
                            where pc.CategoryID == c.id
                            select p;

                return query.ToList();
            }
        }

        public Product GetProduct(int productID)
        {
            using (HowToUnitTestDataContext db = CreateDataContext())
            {
                Product product = db.Products.Single(p => p.id == productID);
                return product;
            }
        }

        private HowToUnitTestDataContext CreateDataContext()
        {
            return new HowToUnitTestDataContext();
        }
    }
}
